/*****************************************************************************
 * container-common.c : support for multi format output
 *****************************************************************************
 * $Id: container-common.c,v 1.9 2005/12/09 21:12:54 pingus77 Exp $
 *****************************************************************************
 * Program under GNU General Public License (see ../COPYING)
 *****************************************************************************/

#include <config.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include "container.h"

extern struct CONTAINER cont_avi;
#ifdef HAVE_FFMPEG
#if LIBAVCODEC_BUILD >= 4754
extern struct CONTAINER cont_ffmpeg_mpeg;
extern struct CONTAINER cont_ffmpeg_mpegts;
extern struct CONTAINER cont_ffmpeg_asf;
extern struct CONTAINER cont_ffmpeg_vob;
extern struct CONTAINER cont_ffmpeg_mov;
extern struct CONTAINER cont_ffmpeg_dv;
extern struct CONTAINER cont_ffmpeg_mp4;
extern struct CONTAINER cont_ffmpeg_3gp;
extern struct CONTAINER cont_ffmpeg_3g2;
extern struct CONTAINER cont_ffmpeg_swf;
extern struct CONTAINER cont_ffmpeg_rm;
#endif
#endif
#ifdef HAVE_OGG
extern struct CONTAINER cont_ogg;
#endif

int container;
struct CONTAINER *containers[] = {
  &cont_avi,
#ifdef HAVE_OGG
  &cont_ogg,
#endif
#ifdef HAVE_FFMPEG
#if LIBAVCODEC_BUILD >= 4754
  &cont_ffmpeg_mpeg,
  &cont_ffmpeg_mpegts,
  &cont_ffmpeg_asf,
  &cont_ffmpeg_vob,
  &cont_ffmpeg_mov,
  &cont_ffmpeg_dv,
  &cont_ffmpeg_mp4,
  &cont_ffmpeg_3gp,
  &cont_ffmpeg_3g2,
  &cont_ffmpeg_swf,
  &cont_ffmpeg_rm,
#endif
#endif
  NULL
};


void force_container(int id){
 int k=0;
 while (containers[k] != NULL) {
	 if (containers[k]->id == id){
		container=k;
		break;
	 }
	 k++;
 }
}

void   set_audio  (struct CONTAINER* thiscont, int channels, long rate,
		  int bits, int format, int brate, int framesize,
		  int audio_vbr)
{
  	AVI_set_audio(thiscont->avfile,channels,rate,bits,format,brate,framesize,audio_vbr);
}
  
void   set_video  (struct CONTAINER* thiscont, int width, int height, int fps_num,
		  int fps_den, char *compressor)
{
	AVI_set_video(thiscont->avfile,width,height,fps_num,fps_den,compressor);
}

