/*****************************************************************************
 * container.h : support for multi format output 
 *****************************************************************************
 * $Id: container.h,v 1.9 2006/02/18 22:12:10 pingus77 Exp $
 *****************************************************************************
 * Program under GNU General Public License (see ../COPYING)
 *****************************************************************************/
#ifndef _XDTV_CONTAINER_H_
#define _XDTV_CONTAINER_H_

#include <config.h>
#include <pthread.h>
#include "avilib.h"
#include "strtab.h"

#ifdef HAVE_FFMPEG
# include "avcodec.h"
#endif

enum {
AVI_BUILTIN,
#ifdef HAVE_OGG
OGG_BUILTIN,
#endif
#ifdef HAVE_FFMPEG
#if LIBAVCODEC_BUILD >= 4754
MPEG_FFMPEG, 
MPEGTS_FFMPEG,
ASF_FFMPEG,
DV_FFMPEG,
VOB_FFMPEG,
MOV_FFMPEG,
MP4_FFMPEG,
_3GP_FFMPEG,
_3G2_FFMPEG,
SWF_FFMPEG,
RM_FFMPEG,
#endif
#endif
};

struct CONTAINER
{
  char* name;
  char* shortname;
  int id;
  char* ext;
  struct STRTAB* v_codecs;
  struct STRTAB* a_codecs;
  avi_t* avfile;
  int (*open_ofile) (struct CONTAINER* This,char* filename,int maxsize);
  void   (*set_audio)  (struct CONTAINER* This, int channels, long rate,
		  int bits, int format, int brate, int framesize,
		  int audio_vbr);
  
  void   (*set_video)  (struct CONTAINER* This, int width, int height, int fps_num,
		  int fps_den, char *compressor);
  int    (*write_frame)(struct CONTAINER* This, char* data, long bytes, long flags);
  int    (*write_audio)(struct CONTAINER* This, char *data, long bytes);
  int 	 (*close)      (struct CONTAINER* This);
  unsigned char*  (*get_header) (struct CONTAINER* This, int* ret_size);
  void   (*set_extradata)(struct CONTAINER* This,unsigned  char* extradata, int extradata_size);

};

void force_container(int id);

void   set_audio  (struct CONTAINER* This, int channels, long rate,
		  int bits, int format, int brate, int framesize,
		  int audio_vbr);
void   set_video  (struct CONTAINER* This, int width, int height, int fps_num,
		  int fps_den, char *compressor);


extern struct CONTAINER *containers[];
extern int container;
#endif
