/*****************************************************************************
 * dvbtools.h: some tools for the DVB-T support
 *****************************************************************************
 * $Id: dvbtools.h,v 1.9 2006/06/26 10:42:10 estre Exp $
 *****************************************************************************
 * Program under GNU General Public License (see ../COPYING)
 *****************************************************************************/



#ifndef DVBTOOLS__H
#define DVBTOOLS__H

#include "config.h"

#ifdef HAVE_DVB

#include <linux/dvb/frontend.h>
#include <linux/dvb/dmx.h>
#define DVB_TRANSPONDER_FILE "/.xdtv/dvb_init.conf"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <signal.h>
#include <pthread.h>
#include <fcntl.h>
#include <ctype.h>

#include "strtab.h"

char FRONTEND_DEV [80];
char DEMUX_DEV [80];
char DVR_DEV [80];

extern const struct STRTAB inversion_list[] ;
extern const struct STRTAB bw_list[]; 
extern const struct STRTAB fec_list[];
extern const struct STRTAB guard_list[];
extern const struct STRTAB hierarchy_list[];
extern const struct STRTAB constellation_list[];
extern const struct STRTAB transmissionmode_list[];
/*
int parse_param (int fd, const Param * plist, int list_size, int *param);
int parse_int(int fd, int *val);
int find_channel(int fd, const char *channel);
int try_parse_int(int fd, int *val, const char *pname);
int try_parse_param(int fd, const Param * plist, int list_size, int *param, const char *pname);
int parse(const char *fname, const char *channel,struct dvb_frontend_parameters *frontend, int *vpid, int *apid, int *spid);
*/

int set_pesfilter (int fd, int pid, dmx_pes_type_t type, int dvr);
int setup_frontend (int fe_fd, struct dvb_frontend_parameters *frontend);
int check_frontend (int fe_fd);
int add_filter(unsigned int pid, const unsigned char* dmxdev);

/*************** tools to get / manage initial transponder file */

#include <string.h>
#include <curl/curl.h>

/* Inclure ici le code de gestion des chanes de caractres */

#define STRING_BLOCK_SIZE 1024
#define LINUXTV_DVBT_CVS_URL "http://linuxtv.org/cgi-bin/viewcvs.cgi/dvb-apps/util/scan/dvb-t/"
#define LINUXTV_DVBT_CVS_CO "http://linuxtv.org/cgi-bin/viewcvs.cgi/*checkout*/dvb-apps/util/scan/dvb-t/"

/* now linuxtv use mercurial instead of CVS */
//#define LINUXTV_DVBT_MERCURIAL_URL "http://linuxtv.org/hg/dvb-apps?mf=dd452313a15d;path=/util/scan/dvb-t/;style=gitweb"
#define LINUXTV_DVBT_MERCURIAL_URL1 "http://linuxtv.org/hg/dvb-apps"
#define LINUXTV_DVBT_MERCURIAL_URL2 "http://linuxtv.org/hg/dvb-apps?mf=xxxxxxxxxxxx;path=/util/scan/dvb-t/;style=gitweb"
#define LINUXTV_DVBT_MERCURIAL_CO_FORM "http://linuxtv.org/hg/dvb-apps?f=ID;file=util/scan/dvb-t/COUNTRY-CITY;style=gitweb"
#define LINUXTV_DVBT_MERCURIAL_CO_DEB "http://linuxtv.org/hg/dvb-apps?f="
#define LINUXTV_DVBT_MERCURIAL_CO_MID ";file=util/scan/dvb-t/"
#define LINUXTV_DVBT_MERCURIAL_CO_END ";style=gitweb"
typedef struct {
	char* str;
	int size;
	int len;
} string_t;

typedef struct {
	char country[3];
	char* city;
	char* id;
}transp_file;

typedef transp_file** transp_pp ;

char * get_URL (const char *url);
transp_file** get_initfiles_list();
struct STRTAB* get_country_list(const transp_pp all_city);
struct STRTAB* get_city_list(const transp_pp all_city, const char* country);
void dvb_write_init_file (const char * datas, FILE* file);
transp_file* get_transp_file(const transp_pp all_city, const char* country, const char* city);

void download_and_save_initfile(const char* dvb_init_conf, const transp_pp all_files , const char* current_country, const char* current_city);
char* get_dvbinit_file_name ();

#endif //HAVE_DVB
#endif //DVBTOOLS_H
