 /******************************************************************************
 * init_label.c: NLS support
 *******************************************************************************
 * $Id: init_labels.c,v 1.36 2007/01/29 12:29:26 estre Exp $
 *****************************************************************************
 * Copyright (C) 2005 Nico
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>

#include "config.h"
#include "strtab.h"
#include "xdtv.h"
#include "divx.h"

#include "translation.h"
#include "init_labels.h"

extern Widget app_shell;
extern char* current_theme;

void 
init_windows_labels(void)
{
	XrmDatabase rb;
	char help_title[50];
	char app_title[50];
	char temp[50];
	char *help_message;

	if (app_shell==NULL)
		return;

	rb = XtDatabase(XtDisplay(app_shell));

	XrmPutStringResource(&rb,"*popup_help.help.ok.label",translate("Close"));
	XrmPutStringResource(&rb,"Options*simple_actions.label",translate("Simple Actions   :     (Shift+)A/H/F/F1"));
	XrmPutStringResource(&rb,"Options*stayontop.label",translate("Stay on Top      :      (No)          T"));
	XrmPutStringResource(&rb,"Options*decoration.label",translate("Window Decoration:     (Yes)          B"));
	XrmPutStringResource(&rb,"Options*graball.label",translate("Grab an Image    :     (Off) (Ctrl+)G/J"));
	XrmPutStringResource(&rb,"Options*record.label",translate("Record Movie     :     (Off)          R"));
	XrmPutStringResource(&rb,"Options*teletext.label",translate("Teletext (AleVT) :     (Off)     Ctrl+A"));
	XrmPutStringResource(&rb,"Options*subpageno.label",translate("Subtitles Page   :   (Other)    Shift+P"));
	XrmPutStringResource(&rb,"Options*Xosd.label",translate("Xosd             :     (Off)     Ctrl+X"));
	XrmPutStringResource(&rb,"Options*togglesub.label",translate("Subtitles        :     (Off)          P"));
	XrmPutStringResource(&rb,"Options*zapping.label",translate("Channel Hopping  :     (Off)   (Ctrl+)Z"));
	XrmPutStringResource(&rb,"Options*norm.label",translate("TV norm           >> Please wait ...."));
	XrmPutStringResource(&rb,"Options*input.label",translate("Video source      >> Please wait ...."));
	XrmPutStringResource(&rb,"Options*freq.label",translate("Frequency table   >> Please wait ...."));
	XrmPutStringResource(&rb,"Options*audio.label",translate("Audio             >> Please wait ...."));
	XrmPutStringResource(&rb,"Options*cap.label",translate("Capture           >> Please wait ...."));
	XrmPutStringResource(&rb,"Options*deinterlace.label",translate("Deinterlace      : None          Ctrl+D"));
	XrmPutStringResource(&rb,"Options*chanwin.label",translate("Open Mozaic Channels..."));
	XrmPutStringResource(&rb,"Options*l_channel_options.label",translate("Channels Options"));
	XrmPutStringResource(&rb,"Options*l_main_actions.label",translate("Main Actions (Ctrl+H)"));
	XrmPutStringResource(&rb,"Options*editorwin.label",translate("Open Channel Editor..."));
	XrmPutStringResource(&rb,"Options*x11paramswin.label",translate("Open X11 Options..."));
	XrmPutStringResource(&rb,"Options*pluginwin.label",translate("Open Plugin Options..."));
	XrmPutStringResource(&rb,"Options*save_config.label",translate("Apply & Save (Shift+S)"));
	XrmPutStringResource(&rb,"Options*quit.label",translate("Quit                                ESC"));
	XrmPutStringResource(&rb,"Options*auto.label",translate("autodetect"));
	XrmPutStringResource(&rb,"Options*mono.label",translate("mono"));
	XrmPutStringResource(&rb,"Options*stereo.label",translate("stereo"));
	XrmPutStringResource(&rb,"Editor*lchannel.label",translate("Channel Number:"));
	XrmPutStringResource(&rb,"Editor*lkey.label",translate("Choose Hotkey:"));
	XrmPutStringResource(&rb,"Editor*lname.label",translate("Station Name:"));
	XrmPutStringResource(&rb,"Editor*moveup.label",translate("Up"));
	XrmPutStringResource(&rb,"Editor*movedown.label",translate("Down"));
	XrmPutStringResource(&rb,"Editor*shortcuts.label",translate("Shortcuts Auto"));
	XrmPutStringResource(&rb,"Editor*editrc.label",translate("Edit RC (use Xterm)"));
	XrmPutStringResource(&rb,"Editor*scantv.label",translate("Scan TV"));
	XrmPutStringResource(&rb,"Editor*fullscan.label",translate("Fullscan Off"));
	XrmPutStringResource(&rb,"Editor*openmain.label",translate("Open Main Options.."));
	XrmPutStringResource(&rb,"Editor*opendvbinit.label",translate("DVB init.."));
	XrmPutStringResource(&rb,"Editor*add.label",translate("Add"));
	XrmPutStringResource(&rb,"Editor*delete.label",translate("Delete"));
	XrmPutStringResource(&rb,"Editor*modify.label",translate("Update"));
	XrmPutStringResource(&rb,"Editor*save.label",translate("Save (Shift+S)"));
	XrmPutStringResource(&rb,"Editor*close.label",translate("Close"));
	#ifdef HAVE_DVB
	XrmPutStringResource(&rb,"DVBinit*ldvbinitrc.label",translate("Edit dvb_init.conf (use Xterm)"));
	XrmPutStringResource(&rb,"DVBinit*ldvbinitlabel.label",translate("Initialize the DVB channels"));
	XrmPutStringResource(&rb,"DVBinit*ldvbinitaction.label",translate("Download & Save"));
	XrmPutStringResource(&rb,"DVBinit*ldvbinitclose.label",translate("Close"));
	#endif
	XrmPutStringResource(&rb,"DivX*lfileformat.label",translate("Choose a Container"));
	XrmPutStringResource(&rb,"DivX*ldivxcodec.label",translate("Choose a Codec"));
	XrmPutStringResource(&rb,"DivX*ldivxcodecaopt.label",translate("Codec Advanced Options (experimental)"));
	XrmPutStringResource(&rb,"DivX*ldivxsize.label",translate("Video Options"));
	XrmPutStringResource(&rb,"DivX*ldivxdisplay.label",translate("Other Options"));
	XrmPutStringResource(&rb,"DivX*ldivxschedule.label",translate("Schedule a Record   :       Need Xterm, At & Cron"));
	XrmPutStringResource(&rb,"DivX*ldivxplayer.label",translate("Preview a Record    :       Mplayer by default   "));
	XrmPutStringResource(&rb,"DivX*ldivxfilepath.label",translate("Path or Path/Name.avi"));
	XrmPutStringResource(&rb,"DivX*ldivxfilepathselector.label",translate("Browse to select a Path..."));
	XrmPutStringResource(&rb,"DivX*ldivxaudioopen.label",translate("Open Audio Recorder Options..."));
	XrmPutStringResource(&rb,"DivX*lstreamopen.label",translate("Open Streaming Server Options..."));
	XrmPutStringResource(&rb,"DivX*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"DivX*ldivxsave.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"DivXAudio*ldivxaudio.label",translate("Audio Options"));
	XrmPutStringResource(&rb,"DivXAudio*ldivxaudiomp3.label",translate("Audio Codec Options"));
	XrmPutStringResource(&rb,"DivXAudio*ldivxaudiovideo.label",translate("Audio/Video Options"));
	XrmPutStringResource(&rb,"DivXAudio*ldivxopen.label",translate("Open Video Recorder Options..."));
	XrmPutStringResource(&rb,"DivXAudio*lstreamopen.label",translate("Open Streaming Server Options..."));
	XrmPutStringResource(&rb,"DivXAudio*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"DivXAudio*ldivxsave.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"SubPage*lsubpagenum.label",translate("Enter Another Subtitle Page Number"));
	XrmPutStringResource(&rb,"SubPage*lsubtitles.label",translate("<<  Start Subtitles  >>"));
	XrmPutStringResource(&rb,"SubPage*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"SubPage*lsubsave.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"*errorPopdown.label",translate("Close"));
	XrmPutStringResource(&rb,"AleVTParams*ldefaultpage.label",translate("Default Page(s): Several AleVT can be started"));
	XrmPutStringResource(&rb,"AleVTParams*lfinetune.label",translate("Finetune Method"));
	XrmPutStringResource(&rb,"AleVTParams*lalevtparams.label",translate("Other AleVT Parameters"));
	XrmPutStringResource(&rb,"AleVTParams*lalevt.label",translate("<<  Start AleVT  >>"));
	XrmPutStringResource(&rb,"AleVTParams*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"AleVTParams*lalevtparamssave.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"x11Params*lx11.label",translate("X11 Options"));
	XrmPutStringResource(&rb,"x11Params*lwmoffby.label",translate("Fullscreen Moving Window (wm-off-by)"));
	XrmPutStringResource(&rb,"x11Params*lpixmaps_size.label",translate("Mozaic Pixmaps Channels Size (pixsize)"));
	XrmPutStringResource(&rb,"x11Params*lxv_info.label",translate("XV Colorkey Info (Grabdisplay)"));
	XrmPutStringResource(&rb,"x11Params*lgframes.label",translate("Max. Width / Height of the grabbed frames"));
	XrmPutStringResource(&rb,"x11Params*l_blackborder.label",translate("Choose a Blackborder"));
	XrmPutStringResource(&rb,"x11Params*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"x11Params*lx11paramssave.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"StreamParams*lstropts.label",translate("Streaming Options"));
	XrmPutStringResource(&rb,"StreamParams*lhttp_port.label",translate("Choose a Http Port"));
	XrmPutStringResource(&rb,"StreamParams*lstreaming.label",translate("<<    Start Streaming Server    >>"));
	XrmPutStringResource(&rb,"StreamParams*ldivxopen.label",translate("Open Video Recorder Options..."));
	XrmPutStringResource(&rb,"StreamParams*ldivxaudioopen.label",translate("Open Audio Recorder Options..."));
	XrmPutStringResource(&rb,"StreamParams*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"StreamParams*lstreamparamssave.label",translate("Apply & Save (Shift+S)"));
	XrmPutStringResource(&rb,"StreamParams*lstreamparamsclose.label",translate("Close"));
	XrmPutStringResource(&rb,"XosdParams*lxosd.label",translate("Common Xosd Options"));
	XrmPutStringResource(&rb,"XosdParams*lmainxosd.label",translate("Main Xosd Options"));
	XrmPutStringResource(&rb,"XosdParams*lvtx.label",translate("Teletext Xosd Options"));
	XrmPutStringResource(&rb,"XosdParams*ltestmainxosd.label",translate("<<  Test & Update Main Xosd  >>"));
	XrmPutStringResource(&rb,"XosdParams*ltestvtxxosd.label",translate("<<  Test & Update Teletext Xosd  >>"));
	XrmPutStringResource(&rb,"XosdParams*lopenmain.label",translate("Open Main Options..."));
	XrmPutStringResource(&rb,"XosdParams*lxosdparamssave.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"*pFileShell*fileMenu.label",translate("File Menu"));
	XrmPutStringResource(&rb,"*fileSelectorDialog*fileSelectorDialogDone.label",translate("Done"));
	XrmPutStringResource(&rb,"*fileSelectorDialog*fileSelectorCancel.label",translate("Cancel"));
	XrmPutStringResource(&rb,"*fileSelectorDialog*fileSelectorFilelabel.label",translate("File"));
	XrmPutStringResource(&rb,"*fileSelectorDialog*fileSelectorDirlabel.label",translate("Folder"));
	XrmPutStringResource(&rb,"*fileMenuButton.label",translate("File & Folder Selector"));
	XrmPutStringResource(&rb,"*fileMenu*allFile.label",translate("All Files"));
	XrmPutStringResource(&rb,"*fileMenu*aviFileOnly.label",translate("*.avi"));
	XrmPutStringResource(&rb,"*fileMenu*jpegFileOnly.label",translate("*.jpeg"));
	XrmPutStringResource(&rb,"*fileMenu*ppmFileOnly.label",translate("*.ppm"));
	XrmPutStringResource(&rb,"*fileMenu*nonSort*label",translate("No Sort"));
	XrmPutStringResource(&rb,"*fileMenu*asciiSort.label",translate("Ascii Sort"));
	XrmPutStringResource(&rb,"*fileMenu*suffixSort.label",translate("Suffix Sort"));
	XrmPutStringResource(&rb,"*fileMenu*dateSort.label",translate("Date Sort"));
	XrmPutStringResource(&rb,"*fileMenu*sizeSort.label",translate("Size Sort"));
	XrmPutStringResource(&rb,"Plugin*lplugclose.label",translate("Close"));
	XrmPutStringResource(&rb,"Grab*lgrab.label",translate("Grab Options"));
	XrmPutStringResource(&rb,"Grab*lgrabfilepath.label",translate("Grab an Image: Choose a Path"));
	XrmPutStringResource(&rb,"Grab*lgrabfilepathselector.label",translate("Browse to select an only Path..."));
	XrmPutStringResource(&rb,"Grab*lgrabclose.label",translate("Apply, Save & Close (Shift+S)"));
	XrmPutStringResource(&rb,"Channels.title",translate("Mozaic Channels"));
	XrmPutStringResource(&rb,"Editor.title",translate("Channel Editor"));
	#ifdef HAVE_DVB
	XrmPutStringResource(&rb,"DVBinit.title",translate("DVB initialization"));
	#endif
	XrmPutStringResource(&rb,"DivX.title",translate("Video Recorder Options"));
	XrmPutStringResource(&rb,"DivXAudio.title",translate("Audio Recorder Options"));
	#ifdef HAVE_FFMPEG
	XrmPutStringResource(&rb,"FFMpeg.title",translate("FFMpeg Options"));
	XrmPutStringResource(&rb,"FFMpeg*lffmpegme.label",translate("Motion Estimation Other Options"));
	XrmPutStringResource(&rb,"FFMpeg*lffmpegquantizers.label",translate("Quantization Other Options"));
	XrmPutStringResource(&rb,"FFMpeg*lffmpegmasking.label",translate("Masking Options"));
	XrmPutStringResource(&rb,"FFMpeg*lffmpegotherset.label",translate("Other Options"));
	XrmPutStringResource(&rb,"FFMpeg*lffmpegvideoopen.label",translate("Open Video Recorder Options..."));
	XrmPutStringResource(&rb,"FFMpeg*lffmpegclose.label",translate("Apply, Save & Close (Shift+S)"));
	#endif
	#ifdef HAVE_XVID
	#ifdef HAVE_XVID10
	XrmPutStringResource(&rb,"XviD.title",translate("XviD Options"));
	XrmPutStringResource(&rb,"XviD*lxvidme.label",translate("Motion Estimation Other Options"));
	XrmPutStringResource(&rb,"XviD*lxvidprofset.label",translate("Advanced Simple Profile Specific Options"));
	XrmPutStringResource(&rb,"XviD*lxvidquantizers.label",translate("Quantization Options"));
	XrmPutStringResource(&rb,"XviD*lxvidotherset.label",translate("Other Options"));
	XrmPutStringResource(&rb,"XviD*lxvidvideoopen.label",translate("Open Video Recorder Options..."));
	XrmPutStringResource(&rb,"XviD*lxvidclose.label",translate("Apply, Save & Close (Shift+S)"));
	#endif
	#endif
	XrmPutStringResource(&rb,"SubPage.title",translate("Subtitle Page No."));
	XrmPutStringResource(&rb,"*pErrorShell.title",translate("Information"));
	XrmPutStringResource(&rb,"AleVTParams.title",translate("AleVT Parameters"));
	XrmPutStringResource(&rb,"x11Params.title",translate("X11 Options"));
	XrmPutStringResource(&rb,"StreamParams.title",translate("Streaming Options"));
	XrmPutStringResource(&rb,"XosdParams.title",translate("Xosd Options"));
	XrmPutStringResource(&rb,"*pFileShell.title",translate("File & Folder Selector"));
	XrmPutStringResource(&rb,"Plugin.title",translate("Plugins"));
	XrmPutStringResource(&rb,"Grab.title",translate("Grab Options"));
	
	sprintf (help_title, translate("XdTV Help %s"), VERSION);
	sprintf (app_title, translate("XdTV %s"), VERSION);

	XrmPutStringResource(&rb,"*popup_help.title",help_title);
	XrmPutStringResource(&rb,"Options.title",app_title);
	sprintf (temp, "%-*s :     %s", ALI(LAB_WIDTH, translate("Theme")),
		 translate(current_theme) );
	XrmPutStringResource(&rb,"Options*Theme.label", temp );
	
	help_message=translate(
"You can use different methods to launch xdTV:\
\n---------------------------------------------\n\
\n\
1) Without any parameter (Xv activated & xvtv_overlay on):\n\
    \n\
    [user@localhost user]$ xdtv\n\
    \n\
    XdTV window can be resized over 768x576.\n\
    YUV mode is used (not RGB mode).\n\
    Grabdisplay is always available (to record).\n\
    This only works in V4L2 mode. If you use V4L1, \n\
    xvtv_overlay is automatically switched off.\n\
    \n\
2) With -noxv parameter:\n\
    \n\
    [user@localhost user]$ xdtv -noxv\n\
    \n\
    If your video card has a buggy Xv support, you can use \n\
    this parameter. By default the X-server Xv support is  \n\
    activated.\n\
   \n\
3) With -xvtv_overlay off parameter:\n\
    \n\
    [user@localhost user]$ xdtv -xvtv_overlay off\n\
    \n\
    The old overlay system is used.\n\
    XdTV window can't be resized over 768x576.\n\
    DGA support is needed.\n\
   \n\
4) With -xvtv parameter:\n\
    \n\
    [user@localhost user]$ xdtv -xvtv\n\
    \n\
    The only way to have the new overlay support\n\
    in v4l1 mode.\n\
    Grabdisplay is not available.\n\
    No recording can be launched.\n\
    AleVT can't be used.\n\
    \n");

	XrmPutStringResource(&rb,"Options.paned.help",help_message);

	XrmPutStringResource(&rb,"Options*l_main_actions.help",help_message);

	XrmPutStringResource(&rb,"xdtv.tv.help",translate(
"Welcome!\n\n\
XdTV is a software to watch, record & stream TV.\
\nIt interacts with AleVT (Teletext) and Nxtvepg (NextView),\n\
and supports the bttv, bktr & dvb APIs.\n\
It contains some deinterlacing filters and record video files\n\
with various containers (AVI, MPEG, OGG, etc.), \n\
and many codecs: FFMpeg >=0.4.6, XviD 0.9 & 1.x, DivX 4 & 5,\n\
Ogg Vorbis + Theora >=1.0a5. It has some plugin capabilities.\n\
\n\
The Original code came from XawTV 2.25 (1998) by Gerd Knorr\n\
\n\
2000-2003 : Original adaptation by Keuleu\n\
2003-2005 : Alain, Bart, Blindman, Calimero, Cooly, CycyX,\n\
            CuC, Mat, Maupatz, Nico, Pingus\n\
2006      : Alain, CuC, Nico, Pingus\n\
\n\
Internationalization : Nico, Pingus, Alain\n\
Themes Creators      : Blindman, Rima\n\
Testers              : Blindman, Hayvan, Mirtouf, Humidifier\n\
\n\
Packagers  :\n\
 Debian    : C. Marillat, Napo\n\
 Fedora    : Pingus\n\
 Gentoo    : Alexis, D. Petteno, TGL\n\
 Mandriva  : Pingus\n\
 Slackware : Glor, Pingus\n\
 Suse      : S. Corot, Pingus\n\
 Ubuntu    : Nico\n\
\n\
Translators:\n\
 Catalan   : Annonygmouse\n\
 French    : Nico, Pingus\n\
 Czech     : P. Mlcoch\n\
 Galician  : M. R. Penabad\n\
 German    : P. Gantner, W. Friedl\n\
 Italian   : A. Palmas\n\
 Polish    : R. Dejewski, T. Torcz, D. Gorazdowski, K. Grzebien\n\
 Russian   : Y. Sokolov\n\
 Spanish   : D. Cordero, F. Cerezal, Donty, F. Alcaraz\n\
 Swedish   : Daniel Nylander\n\
\n\
"));

}

