 /******************************************************************************
 * scan_common.h: internal scan TV
 *******************************************************************************
 * $Id: scan_common.h,v 1.4 2006/06/08 18:48:27 pingus77 Exp $
 *****************************************************************************
 * Copyright (C) 2006 Nico
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#ifndef SCAN_COMMON_H
#define SCAN_COMMON_H

#include "config.h"

#include "grab.h"
#include "channel.h"
#include "channels.h"
#include "strtab.h"


#ifdef HAVE_DVB
#include "dvbtools.h"
#include "dvb/scan.h"
#endif


typedef struct v4l_param_t {
  unsigned long freq;
  char *tvnorm;
  char *freqtab;
  int tvnorm_index;
  int freqtab_index;
  int fullscan;
  int forcev4l1;
  int forcev4l2;
  int forcedvb;
#ifdef HAVE_ZVBI
  struct vbi_raw_decoder *vbi_par;
  size_t services;
  char *err;
#endif
} v4l_param_t;

typedef struct chan_handler_t {
	struct CHANNEL* new_channels;
	int chan_number;
	float current_freq;

	pthread_mutex_t scan_mutex;
	int scan_running;
	pthread_mutex_t in_use_mutex;
	int is_in_use;
	int new_channel_available;

} chan_handler_t ;

void* scan_v4l(void * );

#ifdef HAVE_DVB
void* scan_dvb(void * );
#endif



chan_handler_t* get_chan_handler();
void new_channel_accepted(chan_handler_t* chan_hdl);
int new_channel_available(chan_handler_t* chan_hdl);
void chan_hdl_is_in_use(chan_handler_t* chan_hdl);
void chan_hdl_is_not_in_use(chan_handler_t* chan_hdl);
#endif
