 /******************************************************************************
 * translation.c: NLS support
 *******************************************************************************
 * $Id: translation.c,v 1.9 2005/05/30 08:03:54 alainjj Exp $
 *****************************************************************************
 * Copyright (C) 2005 Nico
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "config.h"
#include "strtab.h"
#include <string.h>

#include "translation.h"

#ifdef HAVE_NLS	
#include <libintl.h>
#include <locale.h>
#endif

void init_localisation(void){
#ifdef HAVE_NLS	
  char domain[50];
  setlocale (LC_ALL, "");
  sprintf(domain,"%s%s",PREFIX,"/share/locale");
  bindtextdomain (PACKAGE, domain);
  textdomain (PACKAGE);
#endif
}

char* 
translate(char* string){
#ifdef HAVE_NLS	
	return gettext(string);
#else 	
	return string;
#endif
} 

void
translate_struct(struct STRTAB *to_translate){
	int i;
	if (NULL != to_translate){
		for (i=0; to_translate[i].str != NULL ; i++){
			to_translate[i].str=translate(to_translate[i].str);
		}
        }
}

struct STRTAB*
translate_struct_copy(struct STRTAB *to_translate){
	int i,l;
	struct STRTAB *s;
	if(to_translate==NULL) return NULL;
	for (l=0; to_translate[l].str != NULL ; l++);
	s=malloc(sizeof(struct STRTAB)*(l+1));
	for(i=0;i<=l;i++) {
	  s[i].nr=to_translate[i].nr;
	  s[i].str=translate(to_translate[i].str);
	}
	return s;
}


char* 
codename_to_name(char* codename ,struct STRTAB * all_codenames,struct STRTAB * all_names ){
	int sizeA=0;
	int sizeB=0;
	int i=0;
	if (NULL != all_codenames){
		for (sizeA=0; all_codenames[sizeA].str != NULL ; sizeA++){
		}
        }else{
		fprintf (stderr, "Error in codename_to_name(), list A is null pointer");
		return NULL;
	}
	if (NULL != all_names){
		for (sizeB=0; all_names[sizeB].str != NULL ; sizeB++){
		}
        }else{
		fprintf (stderr, "Error in codename_to_name(), list A is null pointer");
		return NULL;

	}
	if (sizeA != sizeB){
		fprintf (stderr, "Error in codename_to_name(), not the same size: %d %d",sizeA,sizeB);
		return NULL;
	}
	for (i=0; all_codenames[i].str != NULL ; i++){
			if ( strcmp(codename,all_codenames[i].str)==0){
				break;
			}
	} 
	return all_names[i].str;
}

#ifdef HAVE_NLS
int aligned_needed(int l,char *s) {
  int l1=strlen(s);
  int l2=mbstowcs(NULL,s,0);
  return l+(l1-l2);
}
#endif
